#include <gint/display.h>
#include <gint/keyboard.h>

#include "main.h"

#define K_LEFT 1
#define K_RIGHT 2
#define K_MENU 10
#define K_SHIFT 5


extern bopti_image_t img_grid;
extern bopti_image_t img_whitepawn;
extern bopti_image_t img_blackpawn;

struct select select = {
	.x = 1,
	.pawn = & img_whitepawn
};

struct game game = {
	.turn = 1,
	.tgame = {{0}},
	.select = &select
};

void draw_game(struct game game)
{
	dclear(C_WHITE);

	//On dessine la grille
	dimage(0,14,&img_grid);
	
	//On dessine le sélecteur
	dimage((game.select->x-1)*10+2, 7, game.select->pawn);

	int x = 0;
	int y = 0;
	int dx = 0;
	int dy = 0;

	//On dessine les pions en fonction du tableau tgame
	while(y != 5)
	{
		//Les variables de position pour dessiner
		dx = x*10+2;
		dy = y*10+16;

		if(game.tgame[x][y] == 1)
			dimage(dx, dy, &img_whitepawn);

		if(game.tgame[x][y] == 2)
			dimage(dx, dy, &img_blackpawn);

		x++;
		if(x == 7)
		{
			y++;
			x = 0;
		}
	}

	dupdate();
}

int get_inputs(void)
{
	int opt = GETKEY_DEFAULT;
		
	int key = getkey_opt(opt, NULL).key;

	if(key == KEY_RIGHT) return K_RIGHT;
	if(key == KEY_LEFT) return K_LEFT;
	if(key == KEY_MENU) return K_MENU;
	if(key == KEY_SHIFT) return K_SHIFT;

	//A enlever !! (c'était pour tester les images du pion de sélection)
	if(key == KEY_F1) return 6;	

	return 0;	
}

int main(void)
{
	int key2 = 0;

	while(key2 != K_MENU)
	{
		//On dessine l'écran
		draw_game(game);

		//On récupere les inputs
		key2 = get_inputs();

		//Test couleur des pions
		if(key2 == 6)
		{
			game.turn++;

			if(game.turn == 3)
				game.turn = 1;
		}	

		//On choisit la bonne image de pion en fontion du tour
		if(game.turn == 1)
			game.select->pawn = &img_whitepawn;
		if(game.turn == 2)
			game.select->pawn = &img_blackpawn;

		//On modifie la position x du sélecteur
		if(key2 == K_RIGHT)
			game.select->x++;
		if(key2 == K_LEFT)
			game.select->x--;
		
		//Si le sélecteur dépasse de la grille on le remet de l'autre côté
		if(game.select->x == 8)
			game.select->x = 1;
		if(game.select->x == 0)
			game.select->x = 7;
		
		if(key2 == K_SHIFT)
		{
			int y = 0;
			//Variable de sortie de boucle
			int t = 0;

			//Le y != 5 est là si la colonne est entièrement vide
			while(y != 5 && t != 1)
			{
				//On teste toute la colonne pour savoir jusqu'où descendra le pion
				if(game.tgame[game.select->x][y] == 0)
					y++;
				else
				{
					game.tgame[game.select->x][y-1] = game.turn;
					t = 1;
				}
			}
			if(t == 0)
				game.tgame[game.select->x][4] = game.turn;
		}
	}
	
	return 1;
}
